Release 20040914.
[wine/multimedia.git] / tools / wineprefixcreate.in
blobd72031f9f8a3456df5f9dea99700616396376004
1 #!/bin/sh
3 # Script to create the initial WINEPREFIX directory
5 # Copyright 1999 Ove Kåven
6 # Copyright 2004 Chris Morgan
7 # Copyright 2004 Alexandre Julliard
9 # This library is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU Lesser General Public
11 # License as published by the Free Software Foundation; either
12 # version 2.1 of the License, or (at your option) any later version.
14 # This library is distributed in the hope that it will be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
17 # Lesser General Public License for more details.
19 # You should have received a copy of the GNU Lesser General Public
20 # License along with this library; if not, write to the Free Software
21 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
24 usage()
26 echo "Usage: $0 [options]"
27 echo ""
28 echo "Options:"
29 echo " -h, --help Display this message"
30 echo " --prefix <dir> Directory to create (default: \$WINEPREFIX or ~/.wine)"
31 echo " -q, --quiet Don't print status messages"
32 echo " -u, --update Update the prefix directory if it already exists"
33 echo " --use-wine-tree <dir> Run from the Wine source tree <dir>"
34 echo ""
37 set -e
39 dlldir="@dlldir@"
40 datadir="@datadir@/wine"
42 do_update=0
43 quiet=0
45 while [ $# -gt 0 ]
47 case "$1" in
48 -h|--help)
49 usage
50 exit 0
52 --prefix)
53 WINEPREFIX="$2"
54 shift 2
56 -u|--update)
57 do_update=1
58 shift
60 -q|--quiet)
61 quiet=1
62 shift
64 --use-wine-tree)
65 topdir=`cd "$2" && pwd`
66 if [ -x "$topdir/server/wineserver" ]
67 then
68 WINELOADER="$topdir/wine"
69 dlldir="$topdir/programs"
70 datadir="$topdir/tools"
71 else
72 echo "$2 is not a valid Wine source tree"
73 exit 1
75 shift 2
78 echo "Unknown option $1"
79 usage
80 exit 1
82 esac
83 done
85 WINEPREFIX="${WINEPREFIX:-$HOME/.wine}"
87 if [ -d "$WINEPREFIX" ] || mkdir "$WINEPREFIX"; then :
88 else
89 echo "Could not create $WINEPREFIX, aborting"
90 exit 1
93 WINEPREFIX=`cd "$WINEPREFIX" && pwd`
95 # Create the drive symlinks
97 if [ ! -d "$WINEPREFIX/dosdevices" ]
98 then
99 mkdir "$WINEPREFIX/dosdevices"
100 [ -d "$WINEPREFIX/drive_c" ] || mkdir "$WINEPREFIX/drive_c"
101 ln -s "../drive_c" "$WINEPREFIX/dosdevices/c:"
102 ln -s "/" "$WINEPREFIX/dosdevices/z:"
105 CROOT="$WINEPREFIX/dosdevices/c:"
107 # Create the directory tree
109 for i in \
110 "$CROOT/Program Files" \
111 "$CROOT/Program Files/Common Files" \
112 "$CROOT/windows" \
113 "$CROOT/windows/command" \
114 "$CROOT/windows/fonts" \
115 "$CROOT/windows/inf" \
116 "$CROOT/windows/profiles" \
117 "$CROOT/windows/profiles/Administrator" \
118 "$CROOT/windows/Start Menu" \
119 "$CROOT/windows/Start Menu/Programs" \
120 "$CROOT/windows/Start Menu/Programs/Startup" \
121 "$CROOT/windows/system" \
122 "$CROOT/windows/temp"
124 [ -d "$i" ] || mkdir "$i"
125 done
127 # Create the application symlinks
129 link_app()
131 rm -f "$2" && ln -s "$dlldir/$1.exe.so" "$2" || echo "Warning: failed to create $2"
134 link_app start "$CROOT/windows/command/start.exe"
135 link_app notepad "$CROOT/windows/notepad.exe"
136 link_app regedit "$CROOT/windows/regedit.exe"
137 link_app rundll32 "$CROOT/windows/rundll32.exe"
138 link_app wcmd "$CROOT/windows/system/wcmd.exe"
139 link_app control "$CROOT/windows/system/control.exe"
140 link_app winhelp "$CROOT/windows/system/help.exe"
141 link_app notepad "$CROOT/windows/system/notepad.exe"
142 link_app progman "$CROOT/windows/system/progman.exe"
143 link_app regsvr32 "$CROOT/windows/system/regsvr32.exe"
144 link_app winemine "$CROOT/windows/system/winmine.exe"
145 link_app winver "$CROOT/windows/system/winver.exe"
146 link_app uninstaller "$CROOT/windows/uninstall.exe"
147 link_app winhelp "$CROOT/windows/winhelp.exe"
148 link_app winhelp "$CROOT/windows/winhlp32.exe"
149 link_app winebrowser "$CROOT/windows/winebrowser.exe"
151 # Copy the .inf script and run it
153 cp "$datadir/wine.inf" "$CROOT/windows/inf/wine.inf"
154 export WINEPREFIX
155 ${WINELOADER:-wine} rundll32.exe setupapi.dll,InstallHinfSection DefaultInstall 128 wine.inf
157 # Wait for the wineserver to finish
159 if [ $do_update = 0 ]
160 then
161 ${WINESERVER:-wineserver} -w
162 if [ $quiet = 0 ]
163 then
164 echo "$WINEPREFIX created successfully."
166 else
167 if [ $quiet = 0 ]
168 then
169 echo "$WINEPREFIX updated successfully."